/* Author : Dario GENGA
 * Date : 25.01.2022
 * Description : Contrôle continue 2 - Exercice 3
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct list_t {
    int *value;
    int *index;
    struct list_t *next;
} list;

list *create() {
    list *li = malloc(sizeof(list));
    li->value = NULL;
    li->index = NULL;
    li->next = NULL;
    return li;
}

void destroy(list *li) {
    while (li != NULL) {
        list *tmp = li;
        li = li->next;
        free(tmp);
    }
    free(li);
    li = NULL;
}

list *push(list *li, int *value, int *index) {
    list *new = create();
    new->value = value;
    new->index = index;
    new->next = li;
    return new;
}

void print_pascal(list *li, int pascal_size) {
    list *current = li;
    for (int i = 0; i < pascal_size; i++) {
        if (current != NULL) {
            printf("%d ", *current->value);
            current = current->next;
        }
    }
    printf("\n");
}

list *create_pascal_triangle(list *li, int pascal_size, int size_to_compute, int remaining_step) {
    if (remaining_step == 0 && size_to_compute == pascal_size) {
        // End of the recursion
        print_pascal(li, pascal_size);
        return li;
    }
    if (remaining_step == 0 && size_to_compute != pascal_size) {
        // Start calculating the next row
        return create_pascal_triangle(li, pascal_size, size_to_compute + 1, size_to_compute + 1);
    }

    int index = *li->index + 1;
    if (remaining_step == 1 || remaining_step == size_to_compute) {
        // Add the default value and the start and end of each rows
        int default_value = 1;
        li = push(li, &default_value, &index);
    } else {
        int value = 0;
        list *current = li;
        int current_index = 0;

        // Compute the value by searching the numbers at top and top left
        while (*current->index > *li->index - size_to_compute) {
            if (*current->index == *li->index - (size_to_compute - 1) ||
                *current->index == *li->index - (size_to_compute - 2)) {
                value += *current->value;
            }
            current_index++;
            current = current->next;
        }
        li = push(li, &value, &index);
    }
    return create_pascal_triangle(li, pascal_size, size_to_compute, remaining_step - 1);
}

int main() {
    // Initialize the program
    int default_value = 1;
    int default_index = 0;

    list *li = create();
    li->value = &default_value;
    li->index = &default_index;

    // Get the pascal size from user
    int pascal_size;
    scanf("%d", &pascal_size);

    // Create the triangle
    if (pascal_size > 1) {
        li = create_pascal_triangle(li, pascal_size, 2, 2);
    }

    // Free the memory and exit the program
    destroy(li);
    return EXIT_SUCCESS;
}
